OGRE: Ogre::Mesh Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Mesh Class Reference
Core » Resources

Resource holding data about 3D mesh. More...

`#include <OgreMesh.h>`

Inheritance diagram for Ogre::Mesh:
[legend]

## Public Types
typedef MapIterator< VertexBoneAssignmentList > | BoneAssignmentIterator
typedef ConstVectorIterator< PoseList > | ConstPoseIterator
typedef std::vector< unsigned short > | IndexMap
typedef std::vector< Real > | LodValueList
typedef std::vector< MeshLodUsage > | MeshLodUsageList
typedef VectorIterator< PoseList > | PoseIterator
typedef VectorIterator< SubMeshList > | SubMeshIterator
typedef std::vector< SubMesh * > | SubMeshList
typedef std::unordered_map< String, ushort > | SubMeshNameMap
| A hashmap used to store optional SubMesh names.
typedef std::multimap< size_t, VertexBoneAssignment > | VertexBoneAssignmentList
| Multimap of vertex bone assignments (orders by vertex index).
Public Types inherited from Ogre::Resource
enum | LoadingFlags { LF_DEFAULT = 0 , LF_INCLUDE_NON_RELOADABLE = 1 , LF_ONLY_UNREFERENCED = 2 , LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3 , LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED , LOADSTATE_LOADING , LOADSTATE_LOADED , LOADSTATE_UNLOADING , LOADSTATE_PREPARED , LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
Public Types inherited from Ogre::AnimationContainer
typedef std::map< String, Animation * > | AnimationList

## Public Member Functions
| Mesh (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Default constructor - used by MeshManager.
| ~Mesh ()
void | _calcBoundsFromVertexBuffer (VertexData *vertexData, AxisAlignedBox &outAABB, Real &outRadius, bool updateOnly=false)
| Calculates.
void | _compileBoneAssignments (void)
| Internal method, be called once to compile bone assignments into geometry buffer.
void | _computeBoneBoundingRadius ()
| Compute the bone bounding radius by looking at the vertices, vertex-bone-assignments, and skeleton bind pose.
void | _convertVertexElement (VertexElementSemantic semantic, VertexElementType dstType)
void | _determineAnimationTypes (void) const
| Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).
virtual Animation * | _getAnimationImpl (const String &name) const
| Internal access to the named vertex Animation object - returns null if it does not exist.
bool | _getAnimationTypesDirty (void) const
| Are the derived animation types out of date?
ushort | _getSubMeshIndex (const String &name) const
| Gets the index of a submesh with a given name.
void | _initAnimationState (AnimationStateSet *animSet)
| Initialise an animation set suitable for use with this mesh.
bool | _isManualLodLevel (unsigned short level) const
| Internal methods for loading LOD, do not use.
void | _notifySkeleton (const SkeletonPtr &pSkel)
| Internal notification, used to tell the Mesh which Skeleton to use without loading it.
unsigned short | _rationaliseBoneAssignments (size_t vertexCount, VertexBoneAssignmentList &assignments)
| Rationalises the passed in bone assignment list.
void | _refreshAnimationState (AnimationStateSet *animSet)
| Refresh an animation set suitable for use with this mesh.
void | _setBoneBoundingRadius (Real radius)
| Manually set the bone bounding radius.
void | _setBoundingSphereRadius (Real radius)
| Manually set the bounding radius.
void | _setBounds (const AxisAlignedBox &bounds, bool pad=true)
| Manually set the bounding box for this Mesh.
void | _setLodInfo (unsigned short numLevels)
| Internal methods for loading LOD, do not use.
void | _setLodUsage (unsigned short level, const MeshLodUsage &usage)
| Internal methods for loading LOD, do not use.
void | _setSubMeshLodFaceList (unsigned short subIdx, unsigned short level, IndexData *facedata)
| Internal methods for loading LOD, do not use.
void | _updateBoundsFromVertexBuffers (bool pad=false)
| Automatically update the bounding radius and bounding box for this Mesh.
void | _updateCompiledBoneAssignments (void)
| Internal method, be called once to update the compiled bone assignments.
void | addBoneAssignment (const VertexBoneAssignment &vertBoneAssign)
| Assigns a vertex to a bone with a given weight, for skeletal animation.
void | buildEdgeList (void)
| Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.
void | buildTangentVectors (unsigned short sourceTexCoordSet=0, bool splitMirrored=false, bool splitRotated=false, bool storeParityInW=false)
| This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.
void | buildTangentVectors (VertexElementSemantic targetSemantic, unsigned short sourceTexCoordSet=0, unsigned short index=0, bool splitMirrored=false, bool splitRotated=false, bool storeParityInW=false)
void | clearBoneAssignments (void)
| Removes all bone assignments for this mesh.
MeshPtr | clone (const String &newName, const String &newGroup=BLANKSTRING)
| Makes a copy of this mesh object and gives it a new name.
Animation * | createAnimation (const String &name, Real length) override
| Create a new animation with a given length owned by this container.
Pose * | createPose (ushort target, const String &name=BLANKSTRING)
| Create a new Pose for this mesh or one of its submeshes.
SubMesh * | createSubMesh (const String &name)
| Creates a new SubMesh and gives it a name.
SubMesh * | createSubMesh (void)
| Creates a new SubMesh.
void | createVertexData (HardwareBufferManagerBase *mgr=nullptr)
| Creates a new shared vertex data object.
void | destroySubMesh (const String &name)
| Destroy a SubMesh with the given name.
void | destroySubMesh (unsigned short index)
| Destroy a SubMesh with the given index.
void | freeEdgeList (void)
| Destroys and frees the edge lists this mesh has built.
Animation * | getAnimation (const String &name) const override
| Looks up an Animation object previously created with createAnimation.
Animation * | getAnimation (unsigned short index) const override
| Retrieve an animation by index.
bool | getAutoBuildEdgeLists (void) const
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.
BoneAssignmentIterator | getBoneAssignmentIterator (void)
const VertexBoneAssignmentList & | getBoneAssignments () const
| Gets a const reference to the list of bone assignments.
Real | getBoneBoundingRadius () const
| Gets the radius used to inflate the bounding box around the bones.
Real | getBoundingSphereRadius (void) const
| Gets the radius of the bounding sphere surrounding this mesh.
const AxisAlignedBox & | getBounds (void) const
| Get the axis-aligned bounding box for this mesh.
EdgeData * | getEdgeList (unsigned short lodIndex=0)
| Return the edge list for this mesh, building it if required.
const EdgeData * | getEdgeList (unsigned short lodIndex=0) const
| Return the edge list for this mesh, building it if required.
HardwareBufferManagerBase * | getHardwareBufferManager ()
HardwareBufferUsage | getIndexBufferUsage (void) const
| Gets the usage setting for this meshes index buffers.
ushort | getLodIndex (Real value) const
| Retrieves the level of detail index for the given LOD value.
const MeshLodUsage & | getLodLevel (ushort index) const
| Gets details of the numbered level of detail entry.
const LodStrategy * | getLodStrategy () const
| Get LOD strategy used by this mesh.
unsigned short | getNumAnimations (void) const override
| Gets the number of animations in this container.
ushort | getNumLodLevels (void) const
| Returns the number of levels of detail that this mesh supports.
size_t | getNumSubMeshes (void) const
| Gets the number of sub meshes which comprise this mesh.
Pose * | getPose (const String &name) const
| Retrieve an existing Pose by name.
Pose * | getPose (size_t index) const
| Retrieve an existing Pose by index.
size_t | getPoseCount (void) const
| Get the number of poses.
PoseIterator | getPoseIterator (void)
| Get an iterator over all the poses defined.
ConstPoseIterator | getPoseIterator (void) const
| Get an iterator over all the poses defined.
const PoseList & | getPoseList (void) const
| Get pose list.
bool | getSharedVertexDataAnimationIncludesNormals () const
| Returns whether animation on shared vertex data includes normals.
virtual VertexAnimationType | getSharedVertexDataAnimationType (void) const
| Gets the type of vertex animation the shared vertex data of this mesh supports.
const SkeletonPtr & | getSkeleton (void) const
| Gets a pointer to any linked Skeleton.
const String & | getSkeletonName (void) const
| Gets the name of any linked Skeleton.
SubMesh * | getSubMesh (const String &name) const
| Gets a SubMesh by name.
SubMesh * | getSubMesh (size_t index) const
| Gets a pointer to the submesh indicated by the index.
const SubMeshList & | getSubMeshes () const
| Gets the available submeshes.
SubMeshIterator | getSubMeshIterator (void)
| Gets an iterator over the available submeshes.
const SubMeshNameMap & | getSubMeshNameMap (void) const
| Gets a reference to the optional name assignments of the SubMeshes.
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
HardwareBufferUsage | getVertexBufferUsage (void) const
| Gets the usage setting for this meshes vertex buffers.
VertexData * | getVertexDataByTrackHandle (unsigned short handle)
| Gets a pointer to a vertex data element based on a morph animation track handle.
bool | hasAnimation (const String &name) const override
| Returns whether this object contains the named animation.
bool | hasManualLodLevel (void) const
| Returns true if this mesh has a manual LOD level.
bool | hasSkeleton (void) const
| Returns true if this Mesh has a linked Skeleton.
bool | hasVertexAnimation (void) const
| Returns whether or not this mesh has some kind of vertex animation.
bool | isEdgeListBuilt (void) const
| Returns whether this mesh has an attached edge list.
bool | isIndexBufferShadowed (void) const
| Gets whether or not this meshes index buffers are shadowed.
bool | isPreparedForShadowVolumes (void) const
| Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.
bool | isVertexBufferShadowed (void) const
| Gets whether or not this meshes vertex buffers are shadowed.
void | mergeAdjacentTexcoords (unsigned short finalTexCoordSet, unsigned short texCoordSetToDestroy)
| This method collapses two texcoords into one for all submeshes where this is possible.
void | nameSubMesh (const String &name, ushort index)
| Gives a name to a SubMesh.
void | prepareForShadowVolume (void)
| Modifies the vertex data to be suitable for use for rendering shadow geometry as in [mcguire2003fast].
void | reload (LoadingFlags flags=LF_DEFAULT) override
| Reloads the resource, if it is already loaded.
virtual void | removeAllAnimations (void)
| Removes all morph Animations from this mesh.
void | removeAllPoses (void)
| Destroy all poses.
void | removeAnimation (const String &name) override
| Remove & destroy an Animation from this container.
void | removeLodLevels (void)
| Removes all LOD data from this Mesh.
void | removePose (const String &name)
| Destroy a pose by name.
void | removePose (ushort index)
| Destroy a pose by index.
void | resetVertexData (VertexData *data=nullptr)
| replace the shared vertex data with a new one
void | setAutoBuildEdgeLists (bool autobuild)
| Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.
void | setHardwareBufferManager (HardwareBufferManagerBase *bufferManager)
| Sets the manager for the vertex and index buffers to be used when loading this Mesh.
void | setIndexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the index buffers to be used when loading this Mesh.
void | setLodStrategy (LodStrategy *lodStrategy)
| Set the lod strategy used by this mesh.
void | setSkeletonName (const String &skelName)
| Sets the name of the skeleton this Mesh uses for animation.
void | setVertexBufferPolicy (HardwareBuffer::Usage usage, bool shadowBuffer=false)
| Sets the policy for the vertex buffers to be used when loading this Mesh.
bool | suggestTangentVectorBuildParams (unsigned short &outSourceCoordSet)
| Ask the mesh to suggest a source texture coordinate set to a future buildTangentVectors call.
bool | suggestTangentVectorBuildParams (VertexElementSemantic targetSemantic, unsigned short &outSourceCoordSet, unsigned short &outIndex)
void | unnameSubMesh (const String &name)
| Removes a name from a SubMesh.
void | updateManualLodLevel (ushort index, const String &meshName)
| Changes the alternate mesh to use as a manual LOD at the given index.
Public Member Functions inherited from Ogre::Resource
| Resource (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Standard constructor.
virtual | ~Resource ()
| Virtual destructor.
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed.
void | _fireLoadingComplete (bool unused=false)
| Firing of loading complete event.
void | _firePreparingComplete (bool unused=false)
| Firing of preparing complete event.
void | _fireUnloadingComplete (void)
| Firing of unloading complete event.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | addListener (Listener *lis)
| Register a listener on this resource.
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getGroup (void) const
| Gets the group which this resource is a member of.
ResourceHandle | getHandle (void) const
LoadingState | getLoadingState () const
| Returns the current loading state.
const String & | getName (void) const
| Gets resource name.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
bool | isLoading () const
| Returns whether the resource is currently in the process of background loading.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already.
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::AnimationContainer
virtual | ~AnimationContainer ()

## Static Public Member Functions
static void | prepareMatricesForVertexBlend (const Affine3 **blendMatrices, const Affine3 *boneMatrices, const IndexMap &indexMap)
| Prepare matrices for software indexed vertex blend.
static void | softwareVertexBlend (const VertexData *sourceVertexData, const VertexData *targetVertexData, const Affine3 *const *blendMatrices, size_t numMatrices, bool blendNormals)
| Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.
static void | softwareVertexMorph (float t, const HardwareVertexBufferSharedPtr &b1, const HardwareVertexBufferSharedPtr &b2, VertexData *targetVertexData)
| Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.
static void | softwareVertexPoseBlend (float weight, const std::map< uint32, Vector3f > &vertexOffsetMap, const std::map< uint32, Vector3f > &normalsMap, VertexData *targetVertexData)
| Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Public Attributes
IndexMap | sharedBlendIndexToBoneIndexMap
| Shared index map for translating blend index to bone index.
VertexData * | sharedVertexData
| Shared vertex data.

## Detailed Description

Resource holding data about 3D mesh.

This class holds the data used to represent a discrete 3-dimensional object. Mesh data usually contains more than just vertices and triangle information; it also includes references to materials (and the faces which use them), level-of-detail reduction information, convex hull definition, skeleton/bones information, keyframe animation etc. However, it is important to note the emphasis on the word 'discrete' here. This class does not cover the large-scale sprawling geometry found in level / landscape data.

  Multiple world objects can (indeed should) be created from a single mesh object - see the Entity class for more info. The mesh object will have it's own default material properties, but potentially each world instance may wish to customise the materials from the original. When the object is instantiated into a scene node, the mesh material properties will be taken by default but may be changed. These properties are actually held at the SubMesh level since a single mesh may have parts with different materials.

  As described above, because the mesh may have sections of differing material properties, a mesh is inherently a compound construct, consisting of one or more SubMesh objects. However, it strongly 'owns' it's SubMeshes such that they are loaded / unloaded at the same time. This is contrary to the approach taken to hierarchically related (but loosely owned) scene nodes, where data is loaded / unloaded separately. Note also that mesh sub-sections (when used in an instantiated object) share the same scene node as the parent.

## Member Typedef Documentation

## ◆ LodValueList

typedef std::vector<Real> Ogre::Mesh::LodValueList

## ◆ MeshLodUsageList

typedef std::vector<MeshLodUsage> Ogre::Mesh::MeshLodUsageList

## ◆ VertexBoneAssignmentList

typedef std::multimap<size_t, VertexBoneAssignment> Ogre::Mesh::VertexBoneAssignmentList

Multimap of vertex bone assignments (orders by vertex index).

## ◆ BoneAssignmentIterator

typedef MapIterator<VertexBoneAssignmentList> Ogre::Mesh::BoneAssignmentIterator

## ◆ SubMeshList

typedef std::vector<SubMesh*> Ogre::Mesh::SubMeshList

## ◆ IndexMap

typedef std::vector<unsigned short> Ogre::Mesh::IndexMap

## ◆ SubMeshNameMap

typedef std::unordered_map<String, ushort> Ogre::Mesh::SubMeshNameMap

A hashmap used to store optional SubMesh names.

Translates a name into SubMesh index.

## ◆ SubMeshIterator

typedef VectorIterator<SubMeshList> Ogre::Mesh::SubMeshIterator

## ◆ PoseIterator

typedef VectorIterator<PoseList> Ogre::Mesh::PoseIterator

## ◆ ConstPoseIterator

typedef ConstVectorIterator<PoseList> Ogre::Mesh::ConstPoseIterator

## Constructor & Destructor Documentation

## ◆ Mesh()

Ogre::Mesh::Mesh | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0 )

Default constructor - used by MeshManager.

Warning
  Do not call this method directly.

## ◆ ~Mesh()

Ogre::Mesh::~Mesh | ( |  | ) |

## Member Function Documentation

## ◆ createSubMesh() [1/2]

SubMesh * Ogre::Mesh::createSubMesh | ( | void |  | ) |

Creates a new SubMesh.

Method for manually creating geometry for the mesh. Note - use with extreme caution - you must be sure that you have set up the geometry properly.

References SubMesh.

## ◆ createSubMesh() [2/2]

SubMesh * Ogre::Mesh::createSubMesh | ( | const String & | name | ) |

Creates a new SubMesh and gives it a name.

References SubMesh.

## ◆ nameSubMesh()

void Ogre::Mesh::nameSubMesh | ( | const String & | name,
|  | ushort | index )

Gives a name to a SubMesh.

## ◆ unnameSubMesh()

void Ogre::Mesh::unnameSubMesh | ( | const String & | name | ) |

Removes a name from a SubMesh.

## ◆ _getSubMeshIndex()

ushort Ogre::Mesh::_getSubMeshIndex | ( | const String & | name | ) | const

Gets the index of a submesh with a given name.

Useful if you identify the SubMeshes by name (using nameSubMesh) but wish to have faster repeat access.

## ◆ getNumSubMeshes()

size_t Ogre::Mesh::getNumSubMeshes | ( | void |  | ) | const
| inline

Gets the number of sub meshes which comprise this mesh.

Deprecated
  use getSubMeshes() instead

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getSubMesh() [1/2]

SubMesh * Ogre::Mesh::getSubMesh | ( | size_t | index | ) | const
| inline

Gets a pointer to the submesh indicated by the index.

Deprecated
  use getSubMeshes() instead

References SubMesh.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getSubMesh() [2/2]

SubMesh * Ogre::Mesh::getSubMesh | ( | const String & | name | ) | const

Gets a SubMesh by name.

References SubMesh.

## ◆ destroySubMesh() [1/2]

void Ogre::Mesh::destroySubMesh | ( | unsigned short | index | ) |

Destroy a SubMesh with the given index.

Note
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

## ◆ destroySubMesh() [2/2]

void Ogre::Mesh::destroySubMesh | ( | const String & | name | ) |

Destroy a SubMesh with the given name.

Note
  This will invalidate the contents of any existing Entity, or any other object that is referring to the SubMesh list. Entity will detect this and reinitialise, but it is still a disruptive action.

## ◆ getSubMeshIterator()

SubMeshIterator Ogre::Mesh::getSubMeshIterator | ( | void |  | ) |
| inline

Gets an iterator over the available submeshes.

Deprecated
  use getSubMeshes() instead

## ◆ getSubMeshes()

const SubMeshList & Ogre::Mesh::getSubMeshes | ( |  | ) | const
| inline

Gets the available submeshes.

## ◆ resetVertexData()

void Ogre::Mesh::resetVertexData | ( | VertexData * | data = nullptr | ) |
| inline

replace the shared vertex data with a new one

References sharedVertexData.

Referenced by createVertexData().

## ◆ createVertexData()

void Ogre::Mesh::createVertexData | ( | HardwareBufferManagerBase * | mgr = nullptr | ) |
| inline

Creates a new shared vertex data object.

References resetVertexData().

## ◆ clone()

MeshPtr Ogre::Mesh::clone | ( | const String & | newName,
|  | const String & | newGroup = BLANKSTRING )

Makes a copy of this mesh object and gives it a new name.

This is useful if you want to tweak an existing mesh without affecting the original one. The newly cloned mesh is registered with the MeshManager under the new name.

Parameters

  newName | The name to give the clone.
  newGroup | Optional name of the new group to assign the clone to; if you leave this blank, the clone will be assigned to the same group as this Mesh.

References Ogre::BLANKSTRING.

## ◆ reload()

void Ogre::Mesh::reload | ( | LoadingFlags | flags = LF_DEFAULT | ) |
| overridevirtual

Reloads the resource, if it is already loaded.

Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented from Ogre::Resource.

References Ogre::Resource::LF_DEFAULT.

## ◆ getBounds()

const AxisAlignedBox & Ogre::Mesh::getBounds | ( | void |  | ) | const

Get the axis-aligned bounding box for this mesh.

## ◆ getBoundingSphereRadius()

Real Ogre::Mesh::getBoundingSphereRadius | ( | void |  | ) | const

Gets the radius of the bounding sphere surrounding this mesh.

## ◆ getBoneBoundingRadius()

Real Ogre::Mesh::getBoneBoundingRadius | ( |  | ) | const

Gets the radius used to inflate the bounding box around the bones.

## ◆ _setBounds()

void Ogre::Mesh::_setBounds | ( | const AxisAlignedBox & | bounds,
|  | bool | pad = true )

Manually set the bounding box for this Mesh.

Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

Parameters

  bounds | The axis-aligned bounding box for this mesh
  pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

## ◆ _setBoundingSphereRadius()

void Ogre::Mesh::_setBoundingSphereRadius | ( | Real | radius | ) |

Manually set the bounding radius.

Calling this method is required when building manual meshes now, because OGRE can no longer update the bounds for you, because it cannot necessarily read vertex data back from the vertex buffers which this mesh uses (they very well might be write-only, and even if they are not, reading data from a hardware buffer is a bottleneck).

## ◆ _setBoneBoundingRadius()

void Ogre::Mesh::_setBoneBoundingRadius | ( | Real | radius | ) |

Manually set the bone bounding radius.

This value is normally computed automatically, however it can be overridden with this method.

## ◆ _computeBoneBoundingRadius()

void Ogre::Mesh::_computeBoneBoundingRadius | ( |  | ) |

Compute the bone bounding radius by looking at the vertices, vertex-bone-assignments, and skeleton bind pose.

This is automatically called by Entity if necessary. Only does something if the boneBoundingRadius is zero to begin with. Only works if vertex data is readable (i.e. not WRITE_ONLY).

## ◆ _updateBoundsFromVertexBuffers()

void Ogre::Mesh::_updateBoundsFromVertexBuffers | ( | bool | pad = false | ) |

Automatically update the bounding radius and bounding box for this Mesh.

Calling this method is required when building manual meshes. However it is recommended to use _setBounds and _setBoundingSphereRadius instead, because the vertex buffer may not have a shadow copy in the memory. Reading back the buffer from video memory is very slow!

Parameters

  pad | If true, a certain padding will be added to the bounding box to separate it from the mesh

## ◆ _calcBoundsFromVertexBuffer()

void Ogre::Mesh::_calcBoundsFromVertexBuffer | ( | VertexData * | vertexData,
|  | AxisAlignedBox & | outAABB,
|  | Real & | outRadius,
|  | bool | updateOnly = false )

Calculates.

Calling this method is required when building manual meshes. However it is recommended to use _setBounds and _setBoundingSphereRadius instead, because the vertex buffer may not have a shadow copy in the memory. Reading back the buffer from video memory is very slow!

## ◆ setSkeletonName()

void Ogre::Mesh::setSkeletonName | ( | const String & | skelName | ) |

Sets the name of the skeleton this Mesh uses for animation.

Meshes can optionally be assigned a skeleton which can be used to animate the mesh through bone assignments. The default is for the Mesh to use no skeleton. Calling this method with a valid skeleton filename will cause the skeleton to be loaded if it is not already (a single skeleton can be shared by many Mesh objects).

Parameters

  skelName | The name of the .skeleton file to use, or an empty string to use no skeleton

## ◆ hasSkeleton()

bool Ogre::Mesh::hasSkeleton | ( | void |  | ) | const
| inline

Returns true if this Mesh has a linked Skeleton.

## ◆ hasVertexAnimation()

bool Ogre::Mesh::hasVertexAnimation | ( | void |  | ) | const

Returns whether or not this mesh has some kind of vertex animation.

## ◆ getSkeleton()

const SkeletonPtr & Ogre::Mesh::getSkeleton | ( | void |  | ) | const
| inline

Gets a pointer to any linked Skeleton.

Returns
  Weak reference to the skeleton - copy this if you want to hold a strong pointer.

## ◆ getSkeletonName()

const String & Ogre::Mesh::getSkeletonName | ( | void |  | ) | const

Gets the name of any linked Skeleton.

## ◆ _initAnimationState()

void Ogre::Mesh::_initAnimationState | ( | AnimationStateSet * | animSet | ) |

Initialise an animation set suitable for use with this mesh.

Only recommended for use inside the engine, not by applications.

## ◆ _refreshAnimationState()

void Ogre::Mesh::_refreshAnimationState | ( | AnimationStateSet * | animSet | ) |

Refresh an animation set suitable for use with this mesh.

Only recommended for use inside the engine, not by applications.

## ◆ addBoneAssignment()

void Ogre::Mesh::addBoneAssignment | ( | const VertexBoneAssignment & | vertBoneAssign | ) |

Assigns a vertex to a bone with a given weight, for skeletal animation.

This method is only valid after calling setSkeletonName. Since this is a one-off process there exists only 'addBoneAssignment' and 'clearBoneAssignments' methods, no 'editBoneAssignment'. You should not need to modify bone assignments during rendering (only the positions of bones) and OGRE reserves the right to do some internal data reformatting of this information, depending on render system requirements.

  This method is for assigning weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

## ◆ clearBoneAssignments()

void Ogre::Mesh::clearBoneAssignments | ( | void |  | ) |

Removes all bone assignments for this mesh.

This method is for modifying weights to the shared geometry of the Mesh. To assign weights to the per-SubMesh geometry, see the equivalent methods on SubMesh.

## ◆ _notifySkeleton()

void Ogre::Mesh::_notifySkeleton | ( | const SkeletonPtr & | pSkel | ) |

Internal notification, used to tell the Mesh which Skeleton to use without loading it.

This is only here for unusual situation where you want to manually set up a Skeleton. Best to let OGRE deal with this, don't call it yourself unless you really know what you're doing.

## ◆ getBoneAssignmentIterator()

BoneAssignmentIterator Ogre::Mesh::getBoneAssignmentIterator | ( | void |  | ) |

Deprecated
  use getBoneAssignments

## ◆ getBoneAssignments()

const VertexBoneAssignmentList & Ogre::Mesh::getBoneAssignments | ( |  | ) | const
| inline

Gets a const reference to the list of bone assignments.

## ◆ getNumLodLevels()

ushort Ogre::Mesh::getNumLodLevels | ( | void |  | ) | const
| inline

Returns the number of levels of detail that this mesh supports.

This number includes the original model.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getLodLevel()

const MeshLodUsage & Ogre::Mesh::getLodLevel | ( | ushort | index | ) | const

Gets details of the numbered level of detail entry.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getLodIndex()

ushort Ogre::Mesh::getLodIndex | ( | Real | value | ) | const

Retrieves the level of detail index for the given LOD value.

Note
  The value passed in is the 'transformed' value. If you are dealing with an original source value (e.g. distance), use LodStrategy::transformUserValue to turn this into a lookup value.

## ◆ hasManualLodLevel()

bool Ogre::Mesh::hasManualLodLevel | ( | void |  | ) | const
| inline

Returns true if this mesh has a manual LOD level.

A mesh can either use automatically generated LOD, or it can use alternative meshes as provided by an artist.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ updateManualLodLevel()

void Ogre::Mesh::updateManualLodLevel | ( | ushort | index,
|  | const String & | meshName )

Changes the alternate mesh to use as a manual LOD at the given index.

Note that the index of a LOD may change if you insert other LODs. If in doubt, use getLodIndex().

Parameters

  index | The index of the level to be changed.
  meshName | The name of the mesh which will be the lower level detail version.

## ◆ _setLodInfo()

void Ogre::Mesh::_setLodInfo | ( | unsigned short | numLevels | ) |

Internal methods for loading LOD, do not use.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ _setLodUsage()

void Ogre::Mesh::_setLodUsage | ( | unsigned short | level,
|  | const MeshLodUsage & | usage )

Internal methods for loading LOD, do not use.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ _setSubMeshLodFaceList()

void Ogre::Mesh::_setSubMeshLodFaceList | ( | unsigned short | subIdx,
|  | unsigned short | level,
|  | IndexData * | facedata )

Internal methods for loading LOD, do not use.

## ◆ _isManualLodLevel()

bool Ogre::Mesh::_isManualLodLevel | ( | unsigned short | level | ) | const

Internal methods for loading LOD, do not use.

## ◆ removeLodLevels()

void Ogre::Mesh::removeLodLevels | ( | void |  | ) |

Removes all LOD data from this Mesh.

## ◆ setHardwareBufferManager()

void Ogre::Mesh::setHardwareBufferManager | ( | HardwareBufferManagerBase * | bufferManager | ) |
| inline

Sets the manager for the vertex and index buffers to be used when loading this Mesh.

Parameters

  bufferManager | If set to DefaultHardwareBufferManager, the buffers will be created in system memory only, without hardware counterparts. Such mesh could not be rendered, but LODs could be generated for such mesh, it could be cloned, transformed and serialized.

## ◆ getHardwareBufferManager()

HardwareBufferManagerBase * Ogre::Mesh::getHardwareBufferManager | ( |  | ) |

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ setVertexBufferPolicy()

void Ogre::Mesh::setVertexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = false )

Sets the policy for the vertex buffers to be used when loading this Mesh.

By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method.

Note
  This only takes effect after the Mesh has been reloaded. Also, you still have the option of manually replacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters

  usage | The usage flag, which by default is HBU_GPU_ONLY
  shadowBuffer | If set to `true`, the vertex buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer

## ◆ setIndexBufferPolicy()

void Ogre::Mesh::setIndexBufferPolicy | ( | HardwareBuffer::Usage | usage,
|  | bool | shadowBuffer = false )

Sets the policy for the index buffers to be used when loading this Mesh.

By default, when loading the Mesh, static, write-only vertex and index buffers will be used where possible in order to improve rendering performance. However, such buffers cannot be manipulated on the fly by CPU code (although shader code can). If you wish to use the CPU to modify these buffers, you should call this method.

Note
  This only takes effect after the Mesh has been reloaded. Also, you still have the option of manually replacing the buffers in this mesh with your own if you see fit too, in which case you don't need to call this method since it only affects buffers created by the mesh itself.

You can define the approach to a Mesh by changing the default parameters to MeshManager::load if you wish; this means the Mesh is loaded with those options the first time instead of you having to reload the mesh after changing these options.

Parameters

  usage | The usage flag, which by default is HBU_GPU_ONLY
  shadowBuffer | If set to `true`, the vertex buffers will be created with a system memory shadow buffer. You should set this if you want to be able to read from the buffer

## ◆ getVertexBufferUsage()

HardwareBufferUsage Ogre::Mesh::getVertexBufferUsage | ( | void |  | ) | const
| inline

Gets the usage setting for this meshes vertex buffers.

## ◆ getIndexBufferUsage()

HardwareBufferUsage Ogre::Mesh::getIndexBufferUsage | ( | void |  | ) | const
| inline

Gets the usage setting for this meshes index buffers.

## ◆ isVertexBufferShadowed()

bool Ogre::Mesh::isVertexBufferShadowed | ( | void |  | ) | const
| inline

Gets whether or not this meshes vertex buffers are shadowed.

## ◆ isIndexBufferShadowed()

bool Ogre::Mesh::isIndexBufferShadowed | ( | void |  | ) | const
| inline

Gets whether or not this meshes index buffers are shadowed.

## ◆ _rationaliseBoneAssignments()

unsigned short Ogre::Mesh::_rationaliseBoneAssignments | ( | size_t | vertexCount,
|  | VertexBoneAssignmentList & | assignments )

Rationalises the passed in bone assignment list.

OGRE supports up to 4 bone assignments per vertex. The reason for this limit is that this is the maximum number of assignments that can be passed into a hardware-assisted blending algorithm. This method identifies where there are more than 4 bone assignments for a given vertex, and eliminates the bone assignments with the lowest weights to reduce to this limit. The remaining weights are then re-balanced to ensure that they sum to 1.0.

Parameters

  vertexCount | The number of vertices.
  assignments | The bone assignment list to rationalise. This list will be modified and entries will be removed where the limits are exceeded.

Returns
  The maximum number of bone assignments per vertex found, clamped to [1-4]

## ◆ _compileBoneAssignments()

void Ogre::Mesh::_compileBoneAssignments | ( | void |  | ) |

Internal method, be called once to compile bone assignments into geometry buffer.

The OGRE engine calls this method automatically. It compiles the information submitted as bone assignments into a format usable in realtime. It also eliminates excessive bone assignments (max is OGRE_MAX_BLEND_WEIGHTS) and re-normalises the remaining assignments.

## ◆ _updateCompiledBoneAssignments()

void Ogre::Mesh::_updateCompiledBoneAssignments | ( | void |  | ) |

Internal method, be called once to update the compiled bone assignments.

The OGRE engine calls this method automatically. It updates the compiled bone assignments if requested.

## ◆ mergeAdjacentTexcoords()

void Ogre::Mesh::mergeAdjacentTexcoords | ( | unsigned short | finalTexCoordSet,
|  | unsigned short | texCoordSetToDestroy )

This method collapses two texcoords into one for all submeshes where this is possible.

Often a submesh can have two tex. coords. (i.e. TEXCOORD0 & TEXCOORD1), being both composed of two floats. There are many practical reasons why it would be more convenient to merge both of them into one TEXCOORD0 of 4 floats. This function does exactly that The finalTexCoordSet must have enough space for the merge, or else the submesh will be skipped. (i.e. you can't merge a tex. coord with 3 floats with one having 2 floats)

finalTexCoordSet & texCoordSetToDestroy must be in the same buffer source, and must be adjacent.

Parameters

  finalTexCoordSet | The tex. coord index to merge to. Should have enough space to actually work.
  texCoordSetToDestroy | The texture coordinate index that will disappear on successful merges.

## ◆ buildTangentVectors() [1/2]

void Ogre::Mesh::buildTangentVectors | ( | unsigned short | sourceTexCoordSet = 0,
|  | bool | splitMirrored = false,
|  | bool | splitRotated = false,
|  | bool | storeParityInW = false )

This method builds a set of tangent vectors for a given mesh into a 3D texture coordinate buffer.

Tangent vectors are vectors representing the local 'X' axis for a given vertex based on the orientation of the 2D texture on the geometry. They are built from a combination of existing normals, and from the 2D texture coordinates already baked into the model. They can be used for a number of things, but most of all they are useful for vertex and fragment programs, when you wish to arrive at a common space for doing per-pixel calculations.

  The prerequisites for calling this method include that the vertex data used by every SubMesh has both vertex normals and 2D texture coordinates.

Parameters

  sourceTexCoordSet | The texture coordinate index which should be used as the source of 2D texture coordinates, with which to calculate the tangents.
  splitMirrored | Sets whether or not to split vertices when a mirrored tangent space transition is detected (matrix parity differs). TangentSpaceCalc::setSplitMirrored
  splitRotated | Sets whether or not to split vertices when a rotated tangent space is detected. TangentSpaceCalc::setSplitRotated
  storeParityInW | If `true`, store tangents as a 4-vector and include parity in w.

Referenced by buildTangentVectors().

## ◆ buildTangentVectors() [2/2]

void Ogre::Mesh::buildTangentVectors | ( | VertexElementSemantic | targetSemantic,
|  | unsigned short | sourceTexCoordSet = 0,
|  | unsigned short | index = 0,
|  | bool | splitMirrored = false,
|  | bool | splitRotated = false,
|  | bool | storeParityInW = false )
| inline

Deprecated

References buildTangentVectors(), OgreAssert, and Ogre::VES_TANGENT.

## ◆ suggestTangentVectorBuildParams() [1/2]

bool Ogre::Mesh::suggestTangentVectorBuildParams | ( | unsigned short & | outSourceCoordSet | ) |

Ask the mesh to suggest a source texture coordinate set to a future buildTangentVectors call.

It will detect when there are inappropriate conditions (such as multiple geometry sets which don't agree).

Parameters

  outSourceCoordSet | Reference to a source texture coordinate set which will be used.

Returns
  `true` if it detects that tangents may have been prepared already.

Referenced by suggestTangentVectorBuildParams().

## ◆ suggestTangentVectorBuildParams() [2/2]

bool Ogre::Mesh::suggestTangentVectorBuildParams | ( | VertexElementSemantic | targetSemantic,
|  | unsigned short & | outSourceCoordSet,
|  | unsigned short & | outIndex )
| inline

Deprecated

References OgreAssert, suggestTangentVectorBuildParams(), and Ogre::VES_TANGENT.

## ◆ buildEdgeList()

void Ogre::Mesh::buildEdgeList | ( | void |  | ) |

Builds an edge list for this mesh, which can be used for generating a shadow volume among other things.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ freeEdgeList()

void Ogre::Mesh::freeEdgeList | ( | void |  | ) |

Destroys and frees the edge lists this mesh has built.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ prepareForShadowVolume()

void Ogre::Mesh::prepareForShadowVolume | ( | void |  | ) |

Modifies the vertex data to be suitable for use for rendering shadow geometry as in [mcguire2003fast].

Preparing vertex data to generate a shadow volume involves firstly ensuring that the vertex buffer containing the positions is a standalone vertex buffer, with no other components in it. This method will therefore break apart any existing vertex buffers if position is sharing a vertex buffer. Secondly, it will double the size of this vertex buffer so that there are 2 copies of the position data for the mesh. The first half is used for the original, and the second half is used for the 'extruded' version. The vertex count used to render will remain the same though, so as not to add any overhead to regular rendering of the object. Both copies of the position are required in one buffer because shadow volumes stretch from the original mesh to the extruded version.

It's important to appreciate that this method can fundamentally change the structure of your vertex buffers, although in reality they will be new buffers. As it happens, if other objects are using the original buffers then they will be unaffected because the reference counting will keep them intact. However, if you have made any assumptions about the structure of the vertex data in the buffers of this object, you may have to rethink them.

Because shadow volumes are rendered in turn, no additional index buffer space is allocated by this method, a shared index buffer allocated by the shadow rendering algorithm is used for addressing this extended vertex buffer.

## ◆ getEdgeList() [1/2]

EdgeData * Ogre::Mesh::getEdgeList | ( | unsigned short | lodIndex = 0 | ) |

Return the edge list for this mesh, building it if required.

You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose.

Parameters

  lodIndex | The LOD at which to get the edge list, 0 being the highest.

## ◆ getEdgeList() [2/2]

const EdgeData * Ogre::Mesh::getEdgeList | ( | unsigned short | lodIndex = 0 | ) | const

Return the edge list for this mesh, building it if required.

You must ensure that the Mesh as been prepared for shadow volume rendering if you intend to use this information for that purpose.

Parameters

  lodIndex | The LOD at which to get the edge list, 0 being the highest.

## ◆ isPreparedForShadowVolumes()

bool Ogre::Mesh::isPreparedForShadowVolumes | ( | void |  | ) | const
| inline

Returns whether this mesh has already had it's geometry prepared for use in rendering shadow volumes.

## ◆ isEdgeListBuilt()

bool Ogre::Mesh::isEdgeListBuilt | ( | void |  | ) | const
| inline

Returns whether this mesh has an attached edge list.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ prepareMatricesForVertexBlend()

void Ogre::Mesh::prepareMatricesForVertexBlend | ( | const Affine3 ** | blendMatrices,
|  | const Affine3 * | boneMatrices,
|  | const IndexMap & | indexMap )
| static

Prepare matrices for software indexed vertex blend.

This function organise bone indexed matrices to blend indexed matrices, so software vertex blending can access to the matrix via blend index directly.

Parameters

  blendMatrices | Pointer to an array of matrix pointers to store prepared results, which indexed by blend index.
  boneMatrices | Pointer to an array of matrices to be used to blend, which indexed by bone index.
  indexMap | The index map used to translate blend index to bone index.

## ◆ softwareVertexBlend()

void Ogre::Mesh::softwareVertexBlend | ( | const VertexData * | sourceVertexData,
|  | const VertexData * | targetVertexData,
|  | const Affine3 *const * | blendMatrices,
|  | size_t | numMatrices,
|  | bool | blendNormals )
| static

Performs a software indexed vertex blend, of the kind used for skeletal animation although it can be used for other purposes.

This function is supplied to update vertex data with blends done in software, either because no hardware support is available, or that you need the results of the blend for some other CPU operations.

Parameters

  sourceVertexData | VertexData class containing positions, normals, blend indices and blend weights.
  targetVertexData | VertexData class containing target position and normal buffers which will be updated with the blended versions. Note that the layout of the source and target position / normal buffers must be identical, ie they must use the same buffer indexes
  blendMatrices | Pointer to an array of matrix pointers to be used to blend, indexed by blend indices in the sourceVertexData
  numMatrices | Number of matrices in the blendMatrices, it might be used as a hint for optimisation.
  blendNormals | If `true`, normals are blended as well as positions.

## ◆ softwareVertexMorph()

void Ogre::Mesh::softwareVertexMorph | ( | float | t,
|  | const HardwareVertexBufferSharedPtr & | b1,
|  | const HardwareVertexBufferSharedPtr & | b2,
|  | VertexData * | targetVertexData )
| static

Performs a software vertex morph, of the kind used for morph animation although it can be used for other purposes.

This function will linearly interpolate positions between two source buffers, into a third buffer.

Parameters

  t | Parametric distance between the start and end buffer positions.
  b1 | Vertex buffer containing VET_FLOAT3 entries for the start positions.
  b2 | Vertex buffer containing VET_FLOAT3 entries for the end positions.
  targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end

## ◆ softwareVertexPoseBlend()

void Ogre::Mesh::softwareVertexPoseBlend | ( | float | weight,
|  | const std::map< uint32, Vector3f > & | vertexOffsetMap,
|  | const std::map< uint32, Vector3f > & | normalsMap,
|  | VertexData * | targetVertexData )
| static

Performs a software vertex pose blend, of the kind used for morph animation although it can be used for other purposes.

This function will apply a weighted offset to the positions in the incoming vertex data (therefore this is a read/write operation, and if you expect to call it more than once with the same data, then you would be best to suppress hardware uploads of the position buffer for the duration).

Parameters

  weight | Parametric weight to scale the offsets by.
  vertexOffsetMap | Potentially sparse map of vertex index -> offset.
  normalsMap | Potentially sparse map of vertex index -> normal.
  targetVertexData | VertexData destination; assumed to have a separate position buffer already bound, and the number of vertices must agree with the number in start and end.

## ◆ getSubMeshNameMap()

const SubMeshNameMap & Ogre::Mesh::getSubMeshNameMap | ( | void |  | ) | const
| inline

Gets a reference to the optional name assignments of the SubMeshes.

## ◆ setAutoBuildEdgeLists()

void Ogre::Mesh::setAutoBuildEdgeLists | ( | bool | autobuild | ) |
| inline

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

This allows you to create meshes which do not have edge lists calculated, because you never want to use them. This value defaults to 'true' for mesh formats which did not include edge data, and 'false' for newer formats, where edge lists are expected to have been generated in advance.

## ◆ getAutoBuildEdgeLists()

bool Ogre::Mesh::getAutoBuildEdgeLists | ( | void |  | ) | const
| inline

Sets whether or not this Mesh should automatically build edge lists when asked for them, or whether it should never build them if they are not already provided.

## ◆ getSharedVertexDataAnimationType()

virtual VertexAnimationType Ogre::Mesh::getSharedVertexDataAnimationType | ( | void |  | ) | const
| virtual

Gets the type of vertex animation the shared vertex data of this mesh supports.

## ◆ getSharedVertexDataAnimationIncludesNormals()

bool Ogre::Mesh::getSharedVertexDataAnimationIncludesNormals | ( |  | ) | const
| inline

Returns whether animation on shared vertex data includes normals.

## ◆ createAnimation()

Animation * Ogre::Mesh::createAnimation | ( | const String & | name,
|  | Real | length )
| overridevirtual

Create a new animation with a given length owned by this container.

Parameters

  name | The name of the animation, must be unique within this container.
  length | The length of the animation in seconds

Implements Ogre::AnimationContainer.

## ◆ getAnimation() [1/2]

Animation * Ogre::Mesh::getAnimation | ( | const String & | name | ) | const
| overridevirtual

Looks up an Animation object previously created with createAnimation.

Note
  Throws an exception if the named instance does not exist

Parameters

  name | The name of the animation.

Implements Ogre::AnimationContainer.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ _getAnimationImpl()

virtual Animation * Ogre::Mesh::_getAnimationImpl | ( | const String & | name | ) | const
| virtual

Internal access to the named vertex Animation object - returns null if it does not exist.

Parameters

  name | The name of the animation.

## ◆ hasAnimation()

bool Ogre::Mesh::hasAnimation | ( | const String & | name | ) | const
| overridevirtual

Returns whether this object contains the named animation.

Implements Ogre::AnimationContainer.

## ◆ removeAnimation()

void Ogre::Mesh::removeAnimation | ( | const String & | name | ) |
| overridevirtual

Remove & destroy an Animation from this container.

Implements Ogre::AnimationContainer.

## ◆ getNumAnimations()

unsigned short Ogre::Mesh::getNumAnimations | ( | void |  | ) | const
| overridevirtual

Gets the number of animations in this container.

Implements Ogre::AnimationContainer.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getAnimation() [2/2]

Animation * Ogre::Mesh::getAnimation | ( | unsigned short | index | ) | const
| overridevirtual

Retrieve an animation by index.

Implements Ogre::AnimationContainer.

## ◆ removeAllAnimations()

virtual void Ogre::Mesh::removeAllAnimations | ( | void |  | ) |
| virtual

Removes all morph Animations from this mesh.

## ◆ getVertexDataByTrackHandle()

VertexData * Ogre::Mesh::getVertexDataByTrackHandle | ( | unsigned short | handle | ) |

Gets a pointer to a vertex data element based on a morph animation track handle.

0 means the shared vertex data, 1+ means a submesh vertex data (index+1)

## ◆ _determineAnimationTypes()

void Ogre::Mesh::_determineAnimationTypes | ( | void |  | ) | const

Internal method which, if animation types have not been determined, scans any vertex animations and determines the type for each set of vertex data (cannot have 2 different types).

## ◆ _getAnimationTypesDirty()

bool Ogre::Mesh::_getAnimationTypesDirty | ( | void |  | ) | const
| inline

Are the derived animation types out of date?

## ◆ createPose()

Pose * Ogre::Mesh::createPose | ( | ushort | target,
|  | const String & | name = BLANKSTRING )

Create a new Pose for this mesh or one of its submeshes.

Parameters

  target | The target geometry index; 0 is the shared Mesh geometry, 1+ is the dedicated SubMesh geometry belonging to submesh index + 1.
  name | Name to give the pose, which is optional.

Returns
  A new Pose ready for population.

References Ogre::BLANKSTRING.

## ◆ getPoseCount()

size_t Ogre::Mesh::getPoseCount | ( | void |  | ) | const
| inline

Get the number of poses.

## ◆ getPose() [1/2]

Pose * Ogre::Mesh::getPose | ( | size_t | index | ) | const
| inline

Retrieve an existing Pose by index.

## ◆ getPose() [2/2]

Pose * Ogre::Mesh::getPose | ( | const String & | name | ) | const

Retrieve an existing Pose by name.

## ◆ removePose() [1/2]

void Ogre::Mesh::removePose | ( | ushort | index | ) |

Destroy a pose by index.

Note
  This will invalidate any animation tracks referring to this pose or those after it.

## ◆ removePose() [2/2]

void Ogre::Mesh::removePose | ( | const String & | name | ) |

Destroy a pose by name.

Note
  This will invalidate any animation tracks referring to this pose or those after it.

## ◆ removeAllPoses()

void Ogre::Mesh::removeAllPoses | ( | void |  | ) |

Destroy all poses.

## ◆ getPoseIterator() [1/2]

PoseIterator Ogre::Mesh::getPoseIterator | ( | void |  | ) |

Get an iterator over all the poses defined.

Deprecated
  use getPoseList()

## ◆ getPoseIterator() [2/2]

ConstPoseIterator Ogre::Mesh::getPoseIterator | ( | void |  | ) | const

Get an iterator over all the poses defined.

Deprecated
  use getPoseList()

## ◆ getPoseList()

const PoseList & Ogre::Mesh::getPoseList | ( | void |  | ) | const

Get pose list.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getLodStrategy()

const LodStrategy * Ogre::Mesh::getLodStrategy | ( |  | ) | const

Get LOD strategy used by this mesh.

## ◆ setLodStrategy()

void Ogre::Mesh::setLodStrategy | ( | LodStrategy * | lodStrategy | ) |

Set the lod strategy used by this mesh.

## ◆ _convertVertexElement()

void Ogre::Mesh::_convertVertexElement | ( | VertexElementSemantic | semantic,
|  | VertexElementType | dstType )

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings & Ogre::Mesh::getUserObjectBindings | ( |  | ) |
| inline

Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings & Ogre::Mesh::getUserObjectBindings | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## Member Data Documentation

## ◆ sharedVertexData

VertexData* Ogre::Mesh::sharedVertexData

Shared vertex data.

This vertex data can be shared among multiple submeshes. SubMeshes may not have their own VertexData, they may share this one.

  The use of shared or non-shared buffers is determined when model data is converted to the OGRE .mesh format.

Referenced by resetVertexData(), and Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ sharedBlendIndexToBoneIndexMap

IndexMap Ogre::Mesh::sharedBlendIndexToBoneIndexMap

Shared index map for translating blend index to bone index.

This index map can be shared among multiple submeshes. SubMeshes might not have their own IndexMap, they might share this one.

  We collect actually used bones of all bone assignments, and build the blend index in 'packed' form, then the range of the blend index in vertex data VES_BLEND_INDICES element is continuous, with no gaps. Thus, by minimising the world matrix array constants passing to GPU, we can support more bones for a mesh when hardware skinning is used. The hardware skinning support limit is applied to each set of vertex data in the mesh, in other words, the hardware skinning support limit is applied only to the actually used bones of each SubMeshes, not all bones across the entire Mesh.

  Because the blend index is different to the bone index, therefore, we use the index map to translate the blend index to bone index.

  The use of shared or non-shared index map is determined when model data is converted to the OGRE .mesh format.

The documentation for this class was generated from the following file:

- OgreMesh.h